--This file defines the Armada2 table. This gives access to the rest
--of the tables that you can use, and provides some core functionality.

--Megadroid

Armada2 = {}

	--Get the time that has elapsed since the start of the game
--in seconds
--Returns a number variable
function Armada2.getTime( )
	return _GetTime( )
end

--Play the specified file as a voiceover sound.
function Armada2.playSound( file )
	_PlaySound( file )
end

function Armada2.createDebugConsole( )
	_ArmadaCreateDebugConsole( )
end

--Set if the objectives screen should be visible
function Armada2.showObjectives( value )
	_ArmadaShowObjectives( value )
end

--Set whether the player should be allowed to 
--save the game or not
function Armada2.allowSave( value )
	_ArmadaAllowSave( value )
end

--Get the entity at the specified index.
function Armada2.getEntity( index )
	return Entity:new( _GetEntId( index ) )	
end

--Find a specific craft by name
function Armada2.findCraft( name )
	local count = Armada2.getEntityCount( )
	
	for i = 0, count do
		local ent = Armada2.getEntity( i )
		if( ent:isCraft( ) ) then
			if( ent:getCraftName( ) == name ) then return ent end
		end	
	end
	
	return nil	
end

--Get the number of active entities
function Armada2.getEntityCount( )
	return _GetEntityCount( )
end

--Show message above the minimap
function Armada2.setTeamText( message )
	_SetTeamText( message )
end

--Get the specified team
function Armada2.getTeam( number )
	return Team:new( number )
end
