--This mission allows you to chase the norris around.

messageChase = "Catch the pigeon!"
messageReturn = "Near edge of map, going back to centre. Received reward";

DilithiumRequired = 500
MetalRequired = 750
LatinumRequired = 1000

enterprise = nil
norris = nil
playerTeam = nil

planet = nil

miningBase = nil

objectives = { }

moon = nil

wormholeData = { }

--This is called once at the startof the mission
function init( )
	--Armada2.createDebugConsole( )

	enterprise = Armada2.findCraft( "USS Enterprise-E" )
	norris = Armada2.findCraft( "USS Norris" )
	
	enterprise:setCraftName( "Dick Dastardly and Mutley" )
	norris:setCraftName( "The Pigeon" )
	
	norris:setTeam( 0 )
	
	--Want norris to be on y = 0
	local pos = norris:getPosition( )
	pos.y = 0
	norris:giveMoveOrderPos( pos )
	Armada2.setTeamText( messageChase )
	
	planet = Armada2.findCraft( "D-19872" )
		
	miningBase = Armada2.findCraft( "Station Omicron" )
	miningBase:setTeam( 2 )
	
	playerTeam = Armada2.getTeam( 1 )
	playerTeam:setDilithium( 200 )
	playerTeam:setMetal( 300 )
	playerTeam:setLatinum( 0 )
	
	playerTeam:setRelation( 2, 0 )
	
	Mission.loadObjectives( "mmm1.txt" )
	
	objectives.dilithium = false
	objectives.metal = false
	objectives.latinum = false
	objectives.planet = false
	objectives.miningBase = false
	
	--Show the objectives screen
	Armada2.showObjectives( true )
	
	moon = Armada2.getEntity( 12 )
	
	wormholeData.wormhole = Armada2.getEntity( 15 )
	wormholeData.lastTime = Armada2.getTime( )
	
	enterprise:setAlertStatus( Entity.Alert.Green )
end

--Check for the resource objective
function checkResources( )
	
	
	if( not objectives.dilithium and playerTeam:getDilithium( ) > DilithiumRequired ) then
		objectives.dilithium = true
		Mission.setObjective( 0, true )
		Armada2.playSound( "a2_fed01_generic_objective_1.wav" )
		Armada2.showObjectives( true )
	end
	
	if( not objectives.metal and playerTeam:getMetal( ) > MetalRequired ) then
		objectives.metal = true
		Mission.setObjective( 1, true )
		Armada2.playSound( "a2_fed01_generic_objective_1.wav" )
		Armada2.showObjectives( true )
	end
	
	if( not objectives.latinum and playerTeam:getLatinum( ) > LatinumRequired ) then
		objectives.latinum = true
		Mission.setObjective( 2, true )
		Armada2.playSound( "a2_fed01_generic_objective_1.wav" )
		Armada2.showObjectives( true )
	end
	
end

--Checks for the visibility objective
function checkPlanetVisibility( )
	if( not objectives.planet and planet:canUserSee( ) ) then
		objectives.planet = true
		Mission.setObjective( 3, true )
		Armada2.playSound( "a2_fed01_generic_objective_1.wav" )
		Armada2.showObjectives( true )
	end
end

--Checks to see if the mining station has been killed or not
function checkMiningStation( )
	if( not objectives.miningBase and ( miningBase:isDestroyed( ) or miningBase:getTeam( ) == 1 ) ) then
		Mission.setObjective( 4, true )
		Armada2.showObjectives( true )
		Armada2.playSound( "a2_fed01_generic_objective_1.wav" )
		objectives.miningBase = true
	end
end

--This is called every frame by the mission dll.
function update( )

	centre = Vector3:new( 2000, 0, 2000 )
	
	scale = 500

	total = Armada2.getTime( ) * 0.01
	
	offset = Vector3:new( math.sin( total ), 0, math.cos( total ) ) * 500
	
	if Armada2.getTime( ) - wormholeData.lastTime > 5 then
		wormholeData.wormhole:setPosition( Vector3:new( math.random( 500, 3000 ), 0, math.random( 500, 3000 ) ) )
		wormholeData.lastTime = Armada2.getTime( )
	end
	
	
	moon:setPosition( centre + offset )
	
	checkResources( )
	
	if( planet ) then
		checkPlanetVisibility( )
	end
	
	if( miningBase ) then
		checkMiningStation( )
	end
	
	if( enterprise and norris ) then
		
		local nPos = norris:getPosition( )
		local ePos = enterprise:getPosition(  )
		
		local to = nPos - ePos
		
		if( norris.getBackOnMap ) then
			if( nPos.x > 1950 and nPos.x < 2050 and nPos.z > 1950 and nPos.z < 2050 ) then
				norris.getBackOnMap = false
				Armada2.setTeamText( messageChase )
			end
		else		
			if( to:length( ) < 500 ) then
				to.y = 0
				to:normalize( )
				local distanceWanted = 300
				--Head in the opposite direction to the ship
				to = to * distanceWanted
				
				norris:giveMoveOrderPos( norris:getPosition( ) + to )			
			
			end
			
			if( nPos.x < 500 or nPos.x > 3500 or nPos.z < 500 or nPos.z > 3500 ) then
				norris:giveMoveOrderPos( Vector3:new( 2000, 0, 2000 ) )
				norris.getBackOnMap = true
				Armada2.setTeamText( messageReturn )
				
				playerTeam:addDilithium( math.random( 100, 300 ) )
				playerTeam:addMetal( math.random( 100, 300 ) )
				playerTeam:addLatinum( math.random( 100, 300 ) )
			end
		
		end
		
	end
				
end
