Team = {}

Team.mt = {}

Team.mt.__index = Team

TEAM_ENEMY = 0
TEAM_NEUTRAL = 1
TEAM_ALLY = 2


function Team:new( num )
	return setmetatable( { number = num } , Team.mt )
end

--Resource handling functions

--Get the amount of dilithium that the team has
function Team:getDilithium( )
	return _TeamGetDilithium( self.number )
end

--Get the amount of metal that the team has
function Team:getMetal( ) 
	return _TeamGetMetal( self.number )
end

--Get the amount of crew that the team has
function Team:getCrew( )
	return _TeamGetCrew( self.number )
end

--Get the amount of biomatter that the team has
function Team:getBiomatter( )
	return _TeamGetBiomatter( self.number )
end

--Get the amount of latinum that the team has
function Team:getLatinum( )
	return _TeamGetLatinum( self.number )
end

--Set functions ( absolute value )

--Set the amount of dilithium that the team has
function Team:setDilithium( amount )
	_TeamSetDilithium( self.number, amount )
end

--Set the amount of metal that the team has
function Team:setMetal( amount )
	_TeamSetMetal( self.number, amount )
end

--Set the amount of crew that the team has
function Team:setCrew( amount )
	_TeamSetCrew( self.number, amount )
end

--Set the amount of biomatter that the team has
function Team:setBiomatter( amount )
	_TeamSetBiomatter( self.number, amount )
end

--Set the amount of latinum that the team has
function Team:setLatinum( amount )
	_TeamSetLatinum( self.number, amount )
end

--Relative functions

--Add the specified amount of dilithium to the team
function Team:addDilithium( amount )
	self:setDilithium( self:getDilithium( ) + amount )
end

--Add the specified amount of metal to the team
function Team:addMetal( amount )
	self:setMetal( self:getMetal( ) + amount )
end

--Add the specified amount of crew to the team
function Team:addCrew( amount )
	self:setCrew( self:getCrew( ) + amount )
end

--Add the specified amount of biomatter to the team
function Team:addBiomatter( amount )
	self:setBiomatter( self:getBiomatter( ) + amount )
end

--Add the specified amount of latinum to the team
function Team:addLatinum( amount )
	self:setLatinum( self:getLatinum( ) + amount )
end

--Other functions

--Set relation. See top of Teams.lua for valid states.
function Team:setRelation( team, relation )
	_TeamSetRelation( self.number, team, relation )
end
