--Defines basic types used elsewhere

Vector3 = {}

Vector3.mt = {}

function Vector3:new( px, py, pz )
	local vec = { }
	vec.x = px
	vec.y = py
	vec.z = pz
	return setmetatable( vec, Vector3.mt )
end

function Vector3:length( )
	return math.sqrt( self.x * self.x + self.y * self.y + self.z * self.z )
end

function Vector3:normalize( )
	local length = self:length( )
	self.x = self.x / length;
	self.y = self.y / length;
	self.z = self.z / length;
end

function Vector3:print( )
	print( self.x..","..self.y..","..self.z )
end

function Vector3.add( left, right )
	return Vector3:new( left.x + right.x, left.y + right.y, left.z + right.z )
end

function Vector3.sub( left, right )
	return Vector3:new( left.x - right.x, left.y - right.y, left.z - right.z )
end

function Vector3.div( left, scalar )
	return Vector3:new( left.x / scalar, left.y / scalar, left.z / scalar )
end

function Vector3.mul( left, scalar )
	return Vector3:new( left.x * scalar, left.y * scalar, left.z * scalar )
end

Vector3.mt.__index = Vector3
Vector3.mt.__add = Vector3.add
Vector3.mt.__sub = Vector3.sub
Vector3.mt.__div = Vector3.div
Vector3.mt.__mul = Vector3.mul